// Generated by CoffeeScript 1.6.3
var Mediator, crema, hooks, type, _;

hooks = require("hooks");

type = require("type-component");

crema = require("crema");

_ = require("underscore");

Mediator = (function() {
  /*
  */

  function Mediator() {
    this.commands = {};
    _.extend(this.commands, hooks);
  }

  /*
  */


  Mediator.prototype.on = function(name, callback) {
    var commands;
    if (type(name) === "object") {
      commands = name;
      for (name in commands) {
        this.on(name, commands[name]);
      }
      return;
    }
    return this._register(name, callback);
  };

  /*
  */


  Mediator.prototype.execute = function() {
    var args, name;
    args = Array.prototype.slice.call(arguments);
    name = args.shift();
    if (!this.commands[name]) {
      return;
    }
    return this.commands[name].apply(this.commands, args);
  };

  /*
  */


  Mediator.prototype._register = function(routes, callback) {
    var name, route, _i, _len, _results;
    routes = crema(routes);
    _results = [];
    for (_i = 0, _len = routes.length; _i < _len; _i++) {
      route = routes[_i];
      if (!this.commands[name = route.path.value.substr(1)]) {
        this.commands[name] = function() {};
      }
      if (!route.type) {
        route.type = "hook";
      }
      _results.push(hooks[route.type].call(this.commands, name, callback));
    }
    return _results;
  };

  return Mediator;

})();

module.exports = Mediator;
