// Generated by CoffeeScript 1.6.3
var PaperclipViewDecorator, paperclip, type,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

paperclip = require("paperclip");

type = require("type-component");

PaperclipViewDecorator = (function() {
  /*
  */

  function PaperclipViewDecorator(view) {
    this.view = view;
    this.cleanup = __bind(this.cleanup, this);
    this.remove = __bind(this.remove, this);
    this.render = __bind(this.render, this);
    this._onTemplateChange = __bind(this._onTemplateChange, this);
    this.view.once("render", this.render);
    this.view.once("remove", this.remove);
    this.view._define("paper");
    this.view.bind("paper").to(this._onTemplateChange).now();
  }

  /*
  */


  PaperclipViewDecorator.prototype._onTemplateChange = function(template) {
    if (type(template) !== "function") {
      throw new Error("paper template must be a function for view \"" + this.view.constructor.name + "\"");
    }
    this.template = paperclip.template(template);
    if (this._rendered) {
      this.cleanup(true);
      return this.render();
    }
  };

  /*
  */


  PaperclipViewDecorator.prototype.render = function() {
    this._rendered = true;
    this.content = void 0;
    if (!this.template) {
      return;
    }
    this.content = this.template.bind(this.view);
    this.content.section.show();
    return this.view.section.append(this.content.section.toFragment());
  };

  /*
  */


  PaperclipViewDecorator.prototype.remove = function() {
    return this.cleanup();
  };

  /*
  */


  PaperclipViewDecorator.prototype.cleanup = function(hide) {
    var _ref, _ref1;
    if ((_ref = this.content) != null) {
      _ref.unbind();
    }
    if (hide) {
      return (_ref1 = this.content) != null ? _ref1.section.hide() : void 0;
    }
  };

  /*
  */


  PaperclipViewDecorator.getOptions = function(view) {
    return view.__isView;
  };

  PaperclipViewDecorator.decorate = function(view, options) {
    return new PaperclipViewDecorator(view, options);
  };

  return PaperclipViewDecorator;

})();

module.exports = PaperclipViewDecorator;
